using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace PictureElement
{
	public enum RejimProsmotra
	{
		Prokrutka,
		PodgonRazmera
	}
	/// <summary>
	/// Summary description for UserControl1.
	/// </summary>
	public class NamePictureElement : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private RejimProsmotra prosmotrperemen;


		public NamePictureElement()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			// TODO: Add any initialization after the InitComponent call

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}
		public Image Izobrajenie
		{
			get{return this.pictureBox1.Image;}
			set
			{
				this.pictureBox1.Image = value;
				//     
				this.UstanovkaRejima();
				
			}
		}
		public RejimProsmotra UserPropRejimProsmotra
		{
			get{return this.prosmotrperemen;}
			set
			{						
				this.prosmotrperemen = value;				
				this.AutoScroll = (this.prosmotrperemen == RejimProsmotra.Prokrutka );		
				//     
				this.UstanovkaRejima();				
			}
		}

		private void PodgonRazmera()
		{
			//  ProporciiElementa,   
			//     
			float ProporciiElementa = (float)this.Width/this.Height;
			//  ProporciiIzobrajeniya,   
			//      
			float ProporciiIzobrajeniya = (float)this.pictureBox1.Image.Width/this.pictureBox1.Image.Height;
			//         
			//      ,    
			//  pictureBox1     
			if ( this.Width >= this.pictureBox1.Image.Width && this.Height >= this.pictureBox1.Image.Height )
			{				
				this.pictureBox1.Width = this.pictureBox1.Image.Width;
				this.pictureBox1.Height = this.pictureBox1.Image.Height;				
			}
			//        
			//     ,    
			// pictureBox1     ,       
			//  
			else if( this.Width > this.pictureBox1.Image.Width && this.Height < this.pictureBox1.Image.Height)
			{
				this.pictureBox1.Height = this.Height;
				this.pictureBox1.Width = (int)(this.Height * ProporciiIzobrajeniya);			
			}
			//         
			//      ,    
			// pictureBox1     ,       
			//  
			else if( this.Width < this.pictureBox1.Image.Width && this.Height > this.pictureBox1.Image.Height)
			{				
				this.pictureBox1.Width = this.Width;
				this.pictureBox1.Height = (int)(this.Width / ProporciiIzobrajeniya);									
			}
			//         
			//      
			else if ( this.Width < this.pictureBox1.Image.Width && this.Height < this.pictureBox1.Image.Height )
			{
				//       
				if (this.Width >= this.Height )
				{
					//          
					//ProporciiIzobrajeniya     ProporciiElementa,
					//   pictureBox1    ,
					//      
					if ( this.pictureBox1.Image.Width >= this.pictureBox1.Image.Height && ProporciiIzobrajeniya >= ProporciiElementa )
					{
						this.pictureBox1.Width = this.Width;
						this.pictureBox1.Height = (int)(this.Width / ProporciiIzobrajeniya);
					}
					//     pictureBox1  
					// ,      
					else
					{							
						this.pictureBox1.Height = this.Height;
						this.pictureBox1.Width = (int)(this.Height * ProporciiIzobrajeniya);
					}					
				}
				//
				else
				{
					//         
					//ProporciiIzobrajeniya   ProporciiElementa,
					//    pictureBox1    ,
					//      
					if ( this.pictureBox1.Image.Width < this.pictureBox1.Image.Height && ProporciiIzobrajeniya < ProporciiElementa )
					{						
						this.pictureBox1.Height = this.Height;
						this.pictureBox1.Width = (int)(this.Height * ProporciiIzobrajeniya);
					}
					//     pictureBox1  
					//  ,       
					else 
					{													
						this.pictureBox1.Width = this.Width;
						this.pictureBox1.Height = (int)(this.Width / ProporciiIzobrajeniya);						
					}
				}
			}		
			//      
			PomeshenieIzobrajeniyavCenter();
		}
		private void Prokrutka()
		{
			//   pictureBox1    
			this.pictureBox1.Width = this.pictureBox1.Image.Width;
			//   pictureBox1    
			this.pictureBox1.Height = this.pictureBox1.Image.Height;
			//     
			this.PomeshenieIzobrajeniyavCenter();
		}
		private void UstanovkaRejima()
		{
			// pictureBox1   ,  
			if ( this.pictureBox1.Image == null )
				return;
			//   prosmotrperemen  PodgonRazmera,
			//  PodgonRazmera
			if ( this.prosmotrperemen == RejimProsmotra.PodgonRazmera )
				this.PodgonRazmera();
			//   Prokrutka
			else
			{
				
				this.Prokrutka();	
				this.AutoScroll = true;
			
			}
		}
		private void PomeshenieIzobrajeniyavCenter()
		{
			// top      
			//  pictureBox1,  
			int top = (int)((this.Height - this.pictureBox1.Height)/2.0);
			// left       
			//  pictureBox1,  
			int left = (int)((this.Width - this.pictureBox1.Width)/2.0);
			if ( top < 0 )
				top = 0;
			if ( left < 0 )
				left = 0;
			this.pictureBox1.Top = top;
			this.pictureBox1.Left = left;		
		}


		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(13, 13);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(125, 125);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// NamePictureElement
			// 
			this.Controls.Add(this.pictureBox1);
			this.Name = "NamePictureElement";
			this.Resize += new System.EventHandler(this.NamePictureElement_Resize);
			this.Load += new System.EventHandler(this.NamePictureElement_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void NamePictureElement_Resize(object sender, System.EventArgs e)
		{
		//         :
		this.UstanovkaRejima();
		}

		private void NamePictureElement_Load(object sender, System.EventArgs e)
		{
			//        pictureBox1
			this.pictureBox1.Width = 0;
			this.pictureBox1.Height = 0;
			//     
			this.UstanovkaRejima();
		}
	}
}
