using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Drawing.Printing;

namespace TextEditor
{
	
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.RichTextBox rtbText;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuOpen;
		private System.Windows.Forms.MenuItem mnuSave;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mnuPageSetup;
		private System.Windows.Forms.MenuItem mnuPrintPreview;
		private System.Windows.Forms.MenuItem mnuPrint;
		private System.Windows.Forms.PageSetupDialog pageSetupDialog1;
		private System.Drawing.Printing.PrintDocument printDocument1;
		private System.Windows.Forms.PrintDialog printDialog1;
		private System.Windows.Forms.PrintPreviewDialog printPreviewDialog1;
		//     .
		//       RichTextBox
		string stringPrintText;
		//,   ,     
		int StartPage;
		//,     :
		int NumPages;
		//,    :
		int PageNumber;

		//		PrintDocument printDocument1 = new PrintDocument();
		//		PageSetupDialog  pageSetupDialog1 = new PageSetupDialog();
		//		PrintPreviewDialog printPreviewDialog1 = new PrintPreviewDialog();
		//		PrintDialog printDialog1 = new PrintDialog();

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			
			InitializeComponent();
			//			pageSetupDialog1.Document = printDocument1;
			//			printPreviewDialog1.Document = printDocument1;
			//			printDialog1.Document = printDocument1;
			//			printDialog1.AllowSomePages = true;
			//			printDialog1.AllowSelection = true;
			//
			//  ,     
			printDialog1.PrinterSettings.FromPage = 1;
			//    .
			printDialog1.PrinterSettings.ToPage = printDialog1.PrinterSettings.MaximumPage;

		
		}

	
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.rtbText = new System.Windows.Forms.RichTextBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuOpen = new System.Windows.Forms.MenuItem();
			this.mnuSave = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuPageSetup = new System.Windows.Forms.MenuItem();
			this.mnuPrintPreview = new System.Windows.Forms.MenuItem();
			this.mnuPrint = new System.Windows.Forms.MenuItem();
			this.pageSetupDialog1 = new System.Windows.Forms.PageSetupDialog();
			this.printDocument1 = new System.Drawing.Printing.PrintDocument();
			this.printDialog1 = new System.Windows.Forms.PrintDialog();
			this.printPreviewDialog1 = new System.Windows.Forms.PrintPreviewDialog();
			this.SuspendLayout();
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.FileName = " ";
			this.openFileDialog1.Filter = "Text Files (*.txt)|*.txt|All Files(*.*)|*.*  ";
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.FileName = " ";
			this.saveFileDialog1.Filter = "Text Files (*.txt)|*.txt|All Files(*.*)|*.*  ";
			// 
			// rtbText
			// 
			this.rtbText.Dock = System.Windows.Forms.DockStyle.Fill;
			this.rtbText.Location = new System.Drawing.Point(0, 0);
			this.rtbText.Name = "rtbText";
			this.rtbText.Size = new System.Drawing.Size(292, 266);
			this.rtbText.TabIndex = 1;
			this.rtbText.Text = "";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuOpen,
																					this.mnuSave,
																					this.menuItem1,
																					this.mnuPageSetup,
																					this.mnuPrintPreview,
																					this.mnuPrint});
			this.mnuFile.Text = "&";
			// 
			// mnuOpen
			// 
			this.mnuOpen.Index = 0;
			this.mnuOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.mnuOpen.Text = "&";
			this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
			// 
			// mnuSave
			// 
			this.mnuSave.Index = 1;
			this.mnuSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.mnuSave.Text = "&";
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 2;
			this.menuItem1.Text = "-";
			// 
			// mnuPageSetup
			// 
			this.mnuPageSetup.Index = 3;
			this.mnuPageSetup.Text = "& ";
			this.mnuPageSetup.Click += new System.EventHandler(this.mnuPageSetup_Click);
			// 
			// mnuPrintPreview
			// 
			this.mnuPrintPreview.Index = 4;
			this.mnuPrintPreview.Text = "& ";
			this.mnuPrintPreview.Click += new System.EventHandler(this.mnuPrintPreview_Click);
			// 
			// mnuPrint
			// 
			this.mnuPrint.Index = 5;
			this.mnuPrint.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
			this.mnuPrint.Text = "&";
			this.mnuPrint.Click += new System.EventHandler(this.mnuPrint_Click);
			// 
			// pageSetupDialog1
			// 
			this.pageSetupDialog1.Document = this.printDocument1;
			// 
			// printDocument1
			// 
			this.printDocument1.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocument1_PrintPage);
			// 
			// printDialog1
			// 
			this.printDialog1.AllowSelection = true;
			this.printDialog1.AllowSomePages = true;
			this.printDialog1.Document = this.printDocument1;
			// 
			// printPreviewDialog1
			// 
			this.printPreviewDialog1.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.printPreviewDialog1.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.printPreviewDialog1.ClientSize = new System.Drawing.Size(400, 300);
			this.printPreviewDialog1.Document = this.printDocument1;
			this.printPreviewDialog1.Enabled = true;
			this.printPreviewDialog1.Icon = ((System.Drawing.Icon)(resources.GetObject("printPreviewDialog1.Icon")));
			this.printPreviewDialog1.Location = new System.Drawing.Point(17, 54);
			this.printPreviewDialog1.MinimumSize = new System.Drawing.Size(375, 250);
			this.printPreviewDialog1.Name = "printPreviewDialog1";
			this.printPreviewDialog1.TransparencyKey = System.Drawing.Color.Empty;
			this.printPreviewDialog1.Visible = false;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.rtbText);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "TextEditor";
			this.ResumeLayout(false);

		}
		#endregion

		
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void mnuOpen_Click(object sender, System.EventArgs e)
		{
			//   
			openFileDialog1.ShowDialog() ;
			//  fileName    
			string fileName = openFileDialog1.FileName;
			//  fs     .
			FileStream filestream= File.Open(fileName, FileMode.Open, FileAccess.Read);
			//,    ,    ,  
			if(filestream != null)
			{
				//  streamreader      filestream
				StreamReader streamreader = new StreamReader(filestream /*System.Text.Encoding.Unicode*/);
				//       TextBox
				rtbText.Text = streamreader.ReadToEnd();
				// .
				filestream.Close();
			}
		}

		private void mnuSave_Click(object sender, System.EventArgs e)
		{
			//   
			saveFileDialog1.ShowDialog();
			//        fileName
			string fileName=saveFileDialog1.FileName;
			//  fs     .
			FileStream filestream = File.Open(fileName, FileMode.Create, FileAccess.Write);
				//,    ,    ,  
			if(filestream != null)
			{
				//  streamwriter      filestream
				StreamWriter streamwriter = new StreamWriter(filestream);
				//   TextBox  
				streamwriter.Write(rtbText.Text);
				//     
				streamwriter.Flush();
				// 
				filestream.Close();
			}
		}

		private void mnuPageSetup_Click(object sender, System.EventArgs e)
		{
			// 
			pageSetupDialog1.ShowDialog();
		}

		private void mnuPrintPreview_Click(object sender, System.EventArgs e)
		{
			// 
			printDocument1.DocumentName = Text;
			stringPrintText = rtbText.Text;
			StartPage = 1;
			NumPages = printDialog1.PrinterSettings.MaximumPage;
			PageNumber = 1;
			// 
			printPreviewDialog1.ShowDialog();
		}

		private void mnuPrint_Click(object sender, System.EventArgs e)
		{
			printDialog1.AllowSelection = rtbText.SelectionLength >0;

			if(printDialog1.ShowDialog()==DialogResult.OK)
			{
				printDocument1.DocumentName =Text;
				//    
				switch(printDialog1.PrinterSettings.PrintRange)
				{
						//  
					case PrintRange.AllPages:
						stringPrintText = rtbText.Text;
						StartPage = 1;
						NumPages = printDialog1.PrinterSettings.MaximumPage;
						break;
						//  
					case PrintRange.Selection:
						stringPrintText = rtbText.SelectedText;
						StartPage = 1;
						NumPages = printDialog1.PrinterSettings.MaximumPage;
						break;
						//  
					case PrintRange.SomePages:
						stringPrintText = rtbText.Text;
						StartPage = printDialog1.PrinterSettings.FromPage;
						NumPages = printDialog1.PrinterSettings.ToPage - StartPage+1;
						break;
				}
				PageNumber = 1;
				//     
				printDocument1.Print();
			}
			
		}
		private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			//  graph  Graphics
			Graphics graph = e.Graphics;
			//  font,   
			//   rtbText
			Font font = rtbText.Font;
			//    -   1, 134
			float HeightFont = font.GetHeight(graph);
			//  stringformat  StringFormat   
			//   .
			StringFormat  stringformat = new StringFormat();
			//   rectanglefFull  rectanglefText  RectangleF  
			//    . 1, 104
			RectangleF rectanglefFull, rectanglefText;
			//       .
			int NumberSymbols, NumberLines;
			//      rectanglefFull
			if (graph.VisibleClipBounds.X<0) rectanglefFull = e.MarginBounds;
			else
				//     rectanglefFull
				rectanglefFull = new RectangleF(
					//   X  
					e.MarginBounds.Left - (e.PageBounds.Width - graph.VisibleClipBounds.Width)/2, 
					//   Y
					e.MarginBounds.Top - (e.PageBounds.Height - graph.VisibleClipBounds.Height)/2, 
					//  
					e.MarginBounds.Width,
					//  
					e.MarginBounds.Height);
			rectanglefText = RectangleF.Inflate(rectanglefFull, 0, -2*HeightFont);
			//  
			int NumDisplayLines = (int)Math.Floor(rectanglefText.Height/HeightFont);
			//  
			rectanglefText.Height = NumDisplayLines*HeightFont;
		
			if (rtbText.WordWrap)
			{
				stringformat.Trimming = StringTrimming.Word;
			}
			else
			{
				stringformat.Trimming = StringTrimming.EllipsisCharacter;
				stringformat.FormatFlags |=StringFormatFlags.NoWrap;
			}
			//        
			while ((PageNumber<StartPage)&&(stringPrintText.Length>0))
			{
				if(rtbText.WordWrap)
					//  , 
					// ,      NumberSymbols
					//   NumberLines
					graph.MeasureString(stringPrintText, font, rectanglefText.Size, stringformat, out NumberSymbols, out NumberLines);
				else
					NumberSymbols = SymbolsInLines(stringPrintText, NumDisplayLines);
				stringPrintText = stringPrintText.Substring(NumberSymbols);
				//   
				PageNumber++;
			}
			//   stringPrintText   (   ),
			//  
			if (stringPrintText.Length==0)
			{
				e.Cancel = true;
				return;
			}
			// ()    - stringPrintText,     font,
			//    - Brushes.Black,   - rectanglefText,
			//     stringformat
			graph.DrawString(stringPrintText, font, Brushes.Black, rectanglefText, stringformat);
			//    
			if (rtbText.WordWrap)
				graph.MeasureString(stringPrintText, font, rectanglefText.Size, stringformat, out NumberSymbols, out NumberLines);
			else
				NumberSymbols = SymbolsInLines(stringPrintText, NumDisplayLines);
			stringPrintText = stringPrintText.Substring(NumberSymbols);
			//  stringformat,    .
			stringformat = new StringFormat();
			//       
			stringformat.Alignment = StringAlignment.Far;
			graph.DrawString(" " + PageNumber, font, Brushes.Black, rectanglefFull, stringformat);
			PageNumber++;
			//C ,        ,   
			e.HasMorePages=(stringPrintText.Length>0)&&(PageNumber<StartPage+NumPages);
			//         
			if(!e.HasMorePages)
			{
				stringPrintText = rtbText.Text;
				StartPage = 1;
				NumPages = printDialog1.PrinterSettings.MaximumPage;
				PageNumber = 1;
			}

			
		}
		

		int SymbolsInLines(string stringPrintText, int NumLines)
		{
			int index = 0;
			for (int i = 0; i< NumLines; i++)
			{
				index = 1+ stringPrintText.IndexOf('\n', index);
				if(index==0)
					return stringPrintText.Length;
			}
			return index;
		}

		

		}
	}

